SystemOrganization addCategory: #'ObjectDiff-Sheet'!
SystemOrganization addCategory: #'ObjectDiff-Sheet-Test'!
SystemOrganization addCategory: #'ObjectDiff-Sheet-GUI'!
SystemOrganization addCategory: #'ObjectDiff-System'!
SystemOrganization addCategory: #ObjectDiff!
SystemOrganization addCategory: #'ObjectDiff-Test'!
SystemOrganization addCategory: #'ObjectDiff-GUI'!

!Set methodsFor: '*ObjectDiff-System' stamp: 'HwaJong 10/27/2012 23:10'!
objectDiffKeys
^self isEmpty
	ifTrue: [Array new]
	ifFalse: [1 to: self size]! !

!Set methodsFor: '*ObjectDiff-System' stamp: 'HwaJong 10/28/2012 00:32'!
objectDiffValueAt: anInteger 
^self asArray at: anInteger ! !

!Dictionary methodsFor: '*ObjectDiff-System' stamp: 'HwaJong 10/27/2012 23:08'!
objectDiffKeys
^self keys! !

!Dictionary methodsFor: '*ObjectDiff-System' stamp: 'HwaJong 10/28/2012 00:22'!
objectDiffValueAt: anObject
^self at: anObject! !

!Array methodsFor: '*ObjectDiff' stamp: 'HwaJong 10/28/2012 14:15'!
literalForm
^self collect: #literalForm! !

TestCase subclass: #DiffSheetTest
	instanceVariableNames: 's'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff-Test'!

DiffSheetTest subclass: #DSEqualPointsTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff-Test'!

!DSEqualPointsTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 20:19'!
setUp
super setUp.
s leftSideObject: 2@3.
s rightSideObject: 2@3.
! !

!DSEqualPointsTest methodsFor: 'inner difference' stamp: 'HwaJong 10/31/2012 18:35'!
testCanOpenInnerDifference
self deny: (s canOpenInnerDifferenceAtKey: 'x').
self deny: (s canOpenInnerDifferenceAtKey: 'y').! !

!DSEqualPointsTest methodsFor: 'inner difference' stamp: 'HwaJong 10/31/2012 18:58'!
testCanOpenInnerDifferenceAtKeyIndex1
self deny: (s canOpenInnerDifferenceAtKeyIndex: 1)! !

!DSEqualPointsTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 19:32'!
testCanOpenInspectorLeft1
self assert: (s canOpenLeftInspectorAtRowIndex: 1)! !

!DSEqualPointsTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 20:58'!
testCanOpenInspectorRight1
self assert: (s canOpenRightInspectorAtRowIndex: 1)! !

!DSEqualPointsTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 20:19'!
testComparisonResultInLiterals
self assert: s comparisonResultInLiterals equals: #equal.! !

!DSEqualPointsTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 15:08'!
testLeftSideObjectOfListItemAtRow1
self assert: (s leftSideObjectOfListItemAtRow: 1) equals: (2 @ 3)! !

!DSEqualPointsTest methodsFor: 'list' stamp: 'HwaJong 10/30/2012 00:31'!
testListItemOfKeyAtRow1
self assert: (s listItemOfKeyAtRow: 1) equals: 'object'! !

!DSEqualPointsTest methodsFor: 'list' stamp: 'HwaJong 10/30/2012 00:31'!
testListItemOfTypeAtRow1
self assert: (s listItemOfTypeAtRow: 1) equals: #equal! !

!DSEqualPointsTest methodsFor: 'list' stamp: 'HwaJong 10/28/2012 21:52'!
testListRowSize
self assert: s listRowSize equals: 1! !

!DSEqualPointsTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 16:38'!
testRightSideObjectOfListItemAtRow1
self assert: (s rightSideObjectOfListItemAtRow: 1) equals: (2 @ 3)! !

DiffSheetTest subclass: #DSIdenticalIntegersTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff-Test'!

!DSIdenticalIntegersTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 20:21'!
setUp
super setUp.
s leftSideObject: 37.
s rightSideObject: 37.
! !

!DSIdenticalIntegersTest methodsFor: 'inner difference' stamp: 'HwaJong 10/31/2012 18:35'!
testCanOpenInnerDifference
self deny: (s canOpenInnerDifferenceAtKey: 'foo').
! !

!DSIdenticalIntegersTest methodsFor: 'inner difference' stamp: 'HwaJong 10/31/2012 19:00'!
testCanOpenInnerDifferenceAtKeyIndex1
self deny: (s canOpenInnerDifferenceAtKeyIndex: 1)! !

!DSIdenticalIntegersTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 19:33'!
testCanOpenInspectorLeft1
self assert: (s canOpenLeftInspectorAtRowIndex: 1)! !

!DSIdenticalIntegersTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 21:00'!
testCanOpenInspectorRight1
self assert: (s canOpenRightInspectorAtRowIndex: 1)! !

!DSIdenticalIntegersTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 20:22'!
testComparisonResultInLiterals
self assert: s comparisonResultInLiterals equals: #identical.! !

!DSIdenticalIntegersTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 15:10'!
testLeftSideObjectOfListItemAtRow1
self assert: (s leftSideObjectOfListItemAtRow: 1) equals: 37! !

!DSIdenticalIntegersTest methodsFor: 'list' stamp: 'HwaJong 10/30/2012 00:37'!
testListItemOfKeyAtRow1
self assert: (s listItemOfKeyAtRow: 1) equals: 'object'! !

!DSIdenticalIntegersTest methodsFor: 'list' stamp: 'HwaJong 10/30/2012 00:38'!
testListItemOfTypeAtRow1
self assert: (s listItemOfTypeAtRow: 1) equals: #identical! !

!DSIdenticalIntegersTest methodsFor: 'list' stamp: 'HwaJong 10/28/2012 21:52'!
testListRowSize
self assert: s listRowSize equals: 1! !

!DSIdenticalIntegersTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 16:40'!
testRightSideObjectOfListItemAtRow1
self assert: (s rightSideObjectOfListItemAtRow: 1) equals: 37! !

DiffSheetTest subclass: #DSLeftShortStringTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff-Test'!

!DSLeftShortStringTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 20:28'!
setUp
super setUp.
s leftSideObject: 'hell'.
s rightSideObject: 'hello'.
! !

!DSLeftShortStringTest methodsFor: 'inner difference' stamp: 'HwaJong 10/31/2012 19:00'!
testCanOpenInnerDifferenceAtKeyIndex1
self deny: (s canOpenInnerDifferenceAtKeyIndex: 1)! !

!DSLeftShortStringTest methodsFor: 'inner difference' stamp: 'HwaJong 10/31/2012 19:06'!
testCanOpenInnerDifferenceAtKeyIndex2
self deny: (s canOpenInnerDifferenceAtKeyIndex: 2)! !

!DSLeftShortStringTest methodsFor: 'inner difference' stamp: 'HwaJong 10/31/2012 19:09'!
testCanOpenInnerDifferenceAtKeyIndex3
self deny: (s canOpenInnerDifferenceAtKeyIndex: 3)! !

!DSLeftShortStringTest methodsFor: 'inner difference' stamp: 'HwaJong 10/31/2012 19:09'!
testCanOpenInnerDifferenceAtKeyIndex4
self deny: (s canOpenInnerDifferenceAtKeyIndex: 4)! !

!DSLeftShortStringTest methodsFor: 'inner difference' stamp: 'HwaJong 10/31/2012 19:09'!
testCanOpenInnerDifferenceAtKeyIndex5
self deny: (s canOpenInnerDifferenceAtKeyIndex: 5)! !

!DSLeftShortStringTest methodsFor: 'inner difference' stamp: 'HwaJong 10/31/2012 19:09'!
testCanOpenInnerDifferenceAtKeyIndex6
self deny: (s canOpenInnerDifferenceAtKeyIndex: 6)! !

!DSLeftShortStringTest methodsFor: 'inner difference' stamp: 'HwaJong 10/31/2012 19:07'!
testCanOpenInnerDifferenceAtKeyIndex7
self deny: (s canOpenInnerDifferenceAtKeyIndex: 7)! !

!DSLeftShortStringTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 19:33'!
testCanOpenInspectorLeft1
self assert: (s canOpenLeftInspectorAtRowIndex: 1)! !

!DSLeftShortStringTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 19:35'!
testCanOpenInspectorLeft2
self assert: (s canOpenLeftInspectorAtRowIndex: 2)! !

!DSLeftShortStringTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 19:35'!
testCanOpenInspectorLeft3
self assert: (s canOpenLeftInspectorAtRowIndex: 3)! !

!DSLeftShortStringTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 19:36'!
testCanOpenInspectorLeft7
self deny: (s canOpenLeftInspectorAtRowIndex: 7)! !

!DSLeftShortStringTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 21:01'!
testCanOpenInspectorRight1
self assert: (s canOpenRightInspectorAtRowIndex: 1)! !

!DSLeftShortStringTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 21:03'!
testCanOpenInspectorRight2
self assert: (s canOpenRightInspectorAtRowIndex: 2)! !

!DSLeftShortStringTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 21:03'!
testCanOpenInspectorRight3
self assert: (s canOpenRightInspectorAtRowIndex: 3)! !

!DSLeftShortStringTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 21:04'!
testCanOpenInspectorRight7
self assert: (s canOpenRightInspectorAtRowIndex: 7)! !

!DSLeftShortStringTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 20:28'!
testComparisonResultInLiterals
self assert: s comparisonResultInLiterals equals: #(#(#class #same) #(1 #identical) #(2 #identical) #(3 #identical) #(4 #identical) #(5 #leftMissing)) ! !

!DSLeftShortStringTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 15:11'!
testLeftSideObjectOfListItemAtRow1
self assert: (s leftSideObjectOfListItemAtRow: 1) equals: 'hell'! !

!DSLeftShortStringTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 16:35'!
testLeftSideObjectOfListItemAtRow2
self assert: (s leftSideObjectOfListItemAtRow: 2) equals: ByteString! !

!DSLeftShortStringTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 16:36'!
testLeftSideObjectOfListItemAtRow3
self assert: (s leftSideObjectOfListItemAtRow: 3) equals: $h! !

!DSLeftShortStringTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 16:36'!
testLeftSideObjectOfListItemAtRow4
self assert: (s leftSideObjectOfListItemAtRow: 4) equals: $e! !

!DSLeftShortStringTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 16:37'!
testLeftSideObjectOfListItemAtRow5
self assert: (s leftSideObjectOfListItemAtRow: 5) equals: $l! !

!DSLeftShortStringTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 16:37'!
testLeftSideObjectOfListItemAtRow6
self assert: (s leftSideObjectOfListItemAtRow: 6) equals: $l! !

!DSLeftShortStringTest methodsFor: 'list' stamp: 'HwaJong 10/30/2012 00:51'!
testListItemOfKeyAtRow1
self assert: (s listItemOfKeyAtRow: 1) equals: 'object'! !

!DSLeftShortStringTest methodsFor: 'list' stamp: 'HwaJong 10/30/2012 00:54'!
testListItemOfKeyAtRow2
self assert: (s listItemOfKeyAtRow: 2) equals: 'class'! !

!DSLeftShortStringTest methodsFor: 'list' stamp: 'HwaJong 10/30/2012 00:55'!
testListItemOfKeyAtRow3
self assert: (s listItemOfKeyAtRow: 3) equals: '1'! !

!DSLeftShortStringTest methodsFor: 'list' stamp: 'HwaJong 10/30/2012 00:56'!
testListItemOfKeyAtRow4
self assert: (s listItemOfKeyAtRow: 4) equals: '2'! !

!DSLeftShortStringTest methodsFor: 'list' stamp: 'HwaJong 10/30/2012 00:56'!
testListItemOfKeyAtRow5
self assert: (s listItemOfKeyAtRow: 5) equals: '3'! !

!DSLeftShortStringTest methodsFor: 'list' stamp: 'HwaJong 10/30/2012 00:56'!
testListItemOfKeyAtRow6
self assert: (s listItemOfKeyAtRow: 6) equals: '4'! !

!DSLeftShortStringTest methodsFor: 'list' stamp: 'HwaJong 10/30/2012 00:57'!
testListItemOfKeyAtRow7
self assert: (s listItemOfKeyAtRow: 7) equals: '5'! !

!DSLeftShortStringTest methodsFor: 'list' stamp: 'HwaJong 10/30/2012 01:08'!
testListItemOfLeftSideAtRow7
self assert: (s listItemOfLeftSideAtRow: 7) equals: ''! !

!DSLeftShortStringTest methodsFor: 'list' stamp: 'HwaJong 10/30/2012 00:52'!
testListItemOfTypeAtRow1
self assert: (s listItemOfTypeAtRow: 1) equals: #different! !

!DSLeftShortStringTest methodsFor: 'list' stamp: 'HwaJong 10/30/2012 01:20'!
testListItemOfTypeAtRow2
self assert: (s listItemOfTypeAtRow: 2) equals: #identical! !

!DSLeftShortStringTest methodsFor: 'list' stamp: 'HwaJong 10/30/2012 01:21'!
testListItemOfTypeAtRow3
self assert: (s listItemOfTypeAtRow: 3) equals: #identical! !

!DSLeftShortStringTest methodsFor: 'list' stamp: 'HwaJong 10/30/2012 01:22'!
testListItemOfTypeAtRow4
self assert: (s listItemOfTypeAtRow: 4) equals: #identical! !

!DSLeftShortStringTest methodsFor: 'list' stamp: 'HwaJong 10/30/2012 01:23'!
testListItemOfTypeAtRow5
self assert: (s listItemOfTypeAtRow: 5) equals: #identical! !

!DSLeftShortStringTest methodsFor: 'list' stamp: 'HwaJong 10/30/2012 01:23'!
testListItemOfTypeAtRow6
self assert: (s listItemOfTypeAtRow: 6) equals: #identical! !

!DSLeftShortStringTest methodsFor: 'list' stamp: 'HwaJong 10/30/2012 01:23'!
testListItemOfTypeAtRow7
self assert: (s listItemOfTypeAtRow: 7) equals: #leftMissing! !

!DSLeftShortStringTest methodsFor: 'list' stamp: 'HwaJong 10/31/2012 18:48'!
testListRowSize
self assert: s listRowSize equals: 7! !

!DSLeftShortStringTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 16:44'!
testRightSideObjectOfListItemAtRow1
self assert: (s rightSideObjectOfListItemAtRow: 1) equals: 'hello'! !

!DSLeftShortStringTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 16:44'!
testRightSideObjectOfListItemAtRow2
self assert: (s rightSideObjectOfListItemAtRow: 2) equals: ByteString! !

!DSLeftShortStringTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 16:46'!
testRightSideObjectOfListItemAtRow3
self assert: (s rightSideObjectOfListItemAtRow: 3) equals: $h! !

!DSLeftShortStringTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 16:48'!
testRightSideObjectOfListItemAtRow4
self assert: (s rightSideObjectOfListItemAtRow: 4) equals: $e! !

!DSLeftShortStringTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 16:48'!
testRightSideObjectOfListItemAtRow5
self assert: (s rightSideObjectOfListItemAtRow: 5) equals: $l! !

!DSLeftShortStringTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 16:48'!
testRightSideObjectOfListItemAtRow6
self assert: (s rightSideObjectOfListItemAtRow: 6) equals: $l! !

!DSLeftShortStringTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 16:48'!
testRightSideObjectOfListItemAtRow7
self assert: (s rightSideObjectOfListItemAtRow: 7) equals: $o! !

DiffSheetTest subclass: #DSRectanglePointTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff-Test'!

!DSRectanglePointTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/30/2012 02:55'!
setUp
super setUp.
s leftSideObject: (10@5 corner: 20@20).
s rightSideObject: (7@7).
! !

!DSRectanglePointTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/31/2012 15:05'!
testBalloonText
self assert: (s listItemAtRow: 4) balloonText equals: 
'x:
	
	7'! !

!DSRectanglePointTest methodsFor: 'inner difference' stamp: 'HwaJong 10/31/2012 19:02'!
testCanOpenInnerDifferenceAtKeyIndex1
self deny: (s canOpenInnerDifferenceAtKeyIndex: 1)! !

!DSRectanglePointTest methodsFor: 'inner difference' stamp: 'HwaJong 10/31/2012 19:11'!
testCanOpenInnerDifferenceAtKeyIndex2
self assert: (s canOpenInnerDifferenceAtKeyIndex: 2)! !

!DSRectanglePointTest methodsFor: 'inner difference' stamp: 'HwaJong 10/31/2012 19:11'!
testCanOpenInnerDifferenceAtKeyIndex3
self deny: (s canOpenInnerDifferenceAtKeyIndex: 3)! !

!DSRectanglePointTest methodsFor: 'inner difference' stamp: 'HwaJong 10/31/2012 19:11'!
testCanOpenInnerDifferenceAtKeyIndex4
self deny: (s canOpenInnerDifferenceAtKeyIndex: 4)! !

!DSRectanglePointTest methodsFor: 'inner difference' stamp: 'HwaJong 10/31/2012 19:10'!
testCanOpenInnerDifferenceAtKeyIndex5
self deny: (s canOpenInnerDifferenceAtKeyIndex: 5)! !

!DSRectanglePointTest methodsFor: 'inner difference' stamp: 'HwaJong 10/31/2012 19:10'!
testCanOpenInnerDifferenceAtKeyIndex6
self deny: (s canOpenInnerDifferenceAtKeyIndex: 6)! !

!DSRectanglePointTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 19:33'!
testCanOpenInspectorLeft1
self assert: (s canOpenLeftInspectorAtRowIndex: 1)! !

!DSRectanglePointTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 19:41'!
testCanOpenInspectorLeft2
self assert: (s canOpenLeftInspectorAtRowIndex: 2)! !

!DSRectanglePointTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 19:41'!
testCanOpenInspectorLeft3
self assert: (s canOpenLeftInspectorAtRowIndex: 3)! !

!DSRectanglePointTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 19:41'!
testCanOpenInspectorLeft4
self deny: (s canOpenLeftInspectorAtRowIndex: 4)! !

!DSRectanglePointTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 19:41'!
testCanOpenInspectorLeft5
self deny: (s canOpenLeftInspectorAtRowIndex: 5)! !

!DSRectanglePointTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 19:42'!
testCanOpenInspectorLeft6
self assert: (s canOpenLeftInspectorAtRowIndex: 6)! !

!DSRectanglePointTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 21:05'!
testCanOpenInspectorRight1
self assert: (s canOpenRightInspectorAtRowIndex: 1)! !

!DSRectanglePointTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 21:06'!
testCanOpenInspectorRight2
self assert: (s canOpenRightInspectorAtRowIndex: 2)! !

!DSRectanglePointTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 21:07'!
testCanOpenInspectorRight3
self deny: (s canOpenRightInspectorAtRowIndex: 3)! !

!DSRectanglePointTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 21:06'!
testCanOpenInspectorRight4
self assert: (s canOpenRightInspectorAtRowIndex: 4)! !

!DSRectanglePointTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 21:06'!
testCanOpenInspectorRight5
self assert: (s canOpenRightInspectorAtRowIndex: 5)! !

!DSRectanglePointTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 21:08'!
testCanOpenInspectorRight6
self deny: (s canOpenRightInspectorAtRowIndex: 6)! !

!DSRectanglePointTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/30/2012 02:56'!
testComparisonResultInLiterals
self assert: s comparisonResultInLiterals equals: #(#(#class #different) #('origin' #rightMissing) #('x' #leftMissing) #('y' #leftMissing) #('corner' #rightMissing))! !

!DSRectanglePointTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 15:14'!
testLeftSideObjectOfListItemAtRow1
self assert: (s leftSideObjectOfListItemAtRow: 1) equals: (10@5 corner: 20@20)! !

!DSRectanglePointTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 16:29'!
testLeftSideObjectOfListItemAtRow2
self assert: (s leftSideObjectOfListItemAtRow: 2) equals: Rectangle! !

!DSRectanglePointTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 16:31'!
testLeftSideObjectOfListItemAtRow3
self assert: (s leftSideObjectOfListItemAtRow: 3) equals: (10@5)! !

!DSRectanglePointTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 16:32'!
testLeftSideObjectOfListItemAtRow6
self assert: (s leftSideObjectOfListItemAtRow: 6) equals: (20@20)! !

!DSRectanglePointTest methodsFor: 'list' stamp: 'HwaJong 10/30/2012 03:03'!
testListItemOfKeyAtRow1
self assert: (s listItemOfKeyAtRow: 1) equals: 'object'! !

!DSRectanglePointTest methodsFor: 'list' stamp: 'HwaJong 10/30/2012 03:03'!
testListItemOfKeyAtRow2
self assert: (s listItemOfKeyAtRow: 2) equals: 'class'! !

!DSRectanglePointTest methodsFor: 'list' stamp: 'HwaJong 10/30/2012 03:04'!
testListItemOfKeyAtRow3
self assert: (s listItemOfKeyAtRow: 3) equals: 'origin'! !

!DSRectanglePointTest methodsFor: 'list' stamp: 'HwaJong 10/30/2012 03:04'!
testListItemOfKeyAtRow4
self assert: (s listItemOfKeyAtRow: 4) equals: 'x'! !

!DSRectanglePointTest methodsFor: 'list' stamp: 'HwaJong 10/30/2012 03:04'!
testListItemOfKeyAtRow5
self assert: (s listItemOfKeyAtRow: 5) equals: 'y'! !

!DSRectanglePointTest methodsFor: 'list' stamp: 'HwaJong 10/30/2012 03:05'!
testListItemOfKeyAtRow6
self assert: (s listItemOfKeyAtRow: 6) equals: 'corner'! !

!DSRectanglePointTest methodsFor: 'list' stamp: 'HwaJong 10/30/2012 03:07'!
testListItemOfLeftSideAtRow4
self assert: (s listItemOfLeftSideAtRow: 4) equals: ''! !

!DSRectanglePointTest methodsFor: 'list' stamp: 'HwaJong 10/30/2012 03:07'!
testListItemOfLeftSideAtRow5
self assert: (s listItemOfLeftSideAtRow: 5) equals: ''! !

!DSRectanglePointTest methodsFor: 'list' stamp: 'HwaJong 10/30/2012 03:09'!
testListItemOfRightSideAtRow3
self assert: (s listItemOfRightSideAtRow: 3) equals: ''! !

!DSRectanglePointTest methodsFor: 'list' stamp: 'HwaJong 10/30/2012 03:09'!
testListItemOfRightSideAtRow6
self assert: (s listItemOfRightSideAtRow: 6) equals: ''! !

!DSRectanglePointTest methodsFor: 'list' stamp: 'HwaJong 10/30/2012 03:12'!
testListItemOfTypeAtRow1
self assert: (s listItemOfTypeAtRow: 1) equals: #different! !

!DSRectanglePointTest methodsFor: 'list' stamp: 'HwaJong 10/30/2012 03:11'!
testListItemOfTypeAtRow2
self assert: (s listItemOfTypeAtRow: 2) equals: #different! !

!DSRectanglePointTest methodsFor: 'list' stamp: 'HwaJong 10/30/2012 03:11'!
testListItemOfTypeAtRow3
self assert: (s listItemOfTypeAtRow: 3) equals: #rightMissing! !

!DSRectanglePointTest methodsFor: 'list' stamp: 'HwaJong 10/30/2012 03:10'!
testListItemOfTypeAtRow4
self assert: (s listItemOfTypeAtRow: 4) equals: #leftMissing! !

!DSRectanglePointTest methodsFor: 'list' stamp: 'HwaJong 10/30/2012 03:10'!
testListItemOfTypeAtRow5
self assert: (s listItemOfTypeAtRow: 5) equals: #leftMissing! !

!DSRectanglePointTest methodsFor: 'list' stamp: 'HwaJong 10/30/2012 03:11'!
testListItemOfTypeAtRow6
self assert: (s listItemOfTypeAtRow: 6) equals: #rightMissing! !

!DSRectanglePointTest methodsFor: 'list' stamp: 'HwaJong 10/30/2012 03:02'!
testListRowSize
self assert: s listRowSize equals: 6! !

!DSRectanglePointTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 16:53'!
testRightSideObjectOfListItemAtRow1
self assert: (s rightSideObjectOfListItemAtRow: 1) equals: (7@7)! !

!DSRectanglePointTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 16:53'!
testRightSideObjectOfListItemAtRow2
self assert: (s rightSideObjectOfListItemAtRow: 2) equals: Point! !

!DSRectanglePointTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 16:56'!
testRightSideObjectOfListItemAtRow4
self assert: (s rightSideObjectOfListItemAtRow: 4) equals: 7! !

!DSRectanglePointTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 16:56'!
testRightSideObjectOfListItemAtRow5
self assert: (s rightSideObjectOfListItemAtRow: 5) equals: 7! !

DiffSheetTest subclass: #DSRightDifferentRectanglesTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff-Test'!

!DSRightDifferentRectanglesTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 20:23'!
setUp
super setUp.
s leftSideObject: (2@3 corner: 10@15).
s rightSideObject: (2@3 corner: 20@15).
! !

!DSRightDifferentRectanglesTest methodsFor: 'inner difference' stamp: 'HwaJong 10/31/2012 18:35'!
testCanOpenInnerDifference
self deny: (s canOpenInnerDifferenceAtKey: 'origin').
self assert: (s canOpenInnerDifferenceAtKey: 'corner').
! !

!DSRightDifferentRectanglesTest methodsFor: 'inner difference' stamp: 'HwaJong 10/31/2012 19:02'!
testCanOpenInnerDifferenceAtKeyIndex1
self deny: (s canOpenInnerDifferenceAtKeyIndex: 1)! !

!DSRightDifferentRectanglesTest methodsFor: 'inner difference' stamp: 'HwaJong 10/31/2012 19:14'!
testCanOpenInnerDifferenceAtKeyIndex2
self deny: (s canOpenInnerDifferenceAtKeyIndex: 2)! !

!DSRightDifferentRectanglesTest methodsFor: 'inner difference' stamp: 'HwaJong 10/31/2012 19:14'!
testCanOpenInnerDifferenceAtKeyIndex3
self deny: (s canOpenInnerDifferenceAtKeyIndex: 3)! !

!DSRightDifferentRectanglesTest methodsFor: 'inner difference' stamp: 'HwaJong 10/31/2012 19:13'!
testCanOpenInnerDifferenceAtKeyIndex4
self assert: (s canOpenInnerDifferenceAtKeyIndex: 4)! !

!DSRightDifferentRectanglesTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 19:33'!
testCanOpenInspectorLeft1
self assert: (s canOpenLeftInspectorAtRowIndex: 1)! !

!DSRightDifferentRectanglesTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 19:43'!
testCanOpenInspectorLeft2
self assert: (s canOpenLeftInspectorAtRowIndex: 2)! !

!DSRightDifferentRectanglesTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 19:43'!
testCanOpenInspectorLeft3
self assert: (s canOpenLeftInspectorAtRowIndex: 3)! !

!DSRightDifferentRectanglesTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 19:43'!
testCanOpenInspectorLeft4
self assert: (s canOpenLeftInspectorAtRowIndex: 4)! !

!DSRightDifferentRectanglesTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 21:09'!
testCanOpenInspectorRight1
self assert: (s canOpenRightInspectorAtRowIndex: 1)! !

!DSRightDifferentRectanglesTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 21:09'!
testCanOpenInspectorRight2
self assert: (s canOpenRightInspectorAtRowIndex: 2)! !

!DSRightDifferentRectanglesTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 21:09'!
testCanOpenInspectorRight3
self assert: (s canOpenRightInspectorAtRowIndex: 3)! !

!DSRightDifferentRectanglesTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 21:09'!
testCanOpenInspectorRight4
self assert: (s canOpenRightInspectorAtRowIndex: 4)! !

!DSRightDifferentRectanglesTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 20:24'!
testComparisonResultInLiterals
self assert: s comparisonResultInLiterals equals: #(#(#class #same) #('origin' #equal) #('corner' #different)).
! !

!DSRightDifferentRectanglesTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 15:14'!
testLeftSideObjectOfListItemAtRow1
self assert: (s leftSideObjectOfListItemAtRow: 1) equals: (2@3 corner: 10@15)! !

!DSRightDifferentRectanglesTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 16:27'!
testLeftSideObjectOfListItemAtRow2
self assert: (s leftSideObjectOfListItemAtRow: 2) equals: Rectangle! !

!DSRightDifferentRectanglesTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 16:27'!
testLeftSideObjectOfListItemAtRow3
self assert: (s leftSideObjectOfListItemAtRow: 3) equals: (2@3)! !

!DSRightDifferentRectanglesTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 16:27'!
testLeftSideObjectOfListItemAtRow4
self assert: (s leftSideObjectOfListItemAtRow: 4) equals: (10@15)! !

!DSRightDifferentRectanglesTest methodsFor: 'list' stamp: 'HwaJong 10/30/2012 01:26'!
testListItemOfKeyAtRow1
self assert: (s listItemOfKeyAtRow: 1) equals: 'object'! !

!DSRightDifferentRectanglesTest methodsFor: 'list' stamp: 'HwaJong 10/30/2012 01:26'!
testListItemOfKeyAtRow2
self assert: (s listItemOfKeyAtRow: 2) equals: 'class'! !

!DSRightDifferentRectanglesTest methodsFor: 'list' stamp: 'HwaJong 10/30/2012 01:26'!
testListItemOfKeyAtRow3
self assert: (s listItemOfKeyAtRow: 3) equals: 'origin'! !

!DSRightDifferentRectanglesTest methodsFor: 'list' stamp: 'HwaJong 10/30/2012 01:28'!
testListItemOfKeyAtRow4
self assert: (s listItemOfKeyAtRow: 4) equals: 'corner'! !

!DSRightDifferentRectanglesTest methodsFor: 'list' stamp: 'HwaJong 10/30/2012 01:35'!
testListItemOfTypeAtRow1
self assert: (s listItemOfTypeAtRow: 1) equals: #different! !

!DSRightDifferentRectanglesTest methodsFor: 'list' stamp: 'HwaJong 10/30/2012 01:35'!
testListItemOfTypeAtRow2
self assert: (s listItemOfTypeAtRow: 2) equals: #identical! !

!DSRightDifferentRectanglesTest methodsFor: 'list' stamp: 'HwaJong 10/30/2012 01:36'!
testListItemOfTypeAtRow3
self assert: (s listItemOfTypeAtRow: 3) equals: #equal! !

!DSRightDifferentRectanglesTest methodsFor: 'list' stamp: 'HwaJong 10/30/2012 01:37'!
testListItemOfTypeAtRow4
self assert: (s listItemOfTypeAtRow: 4) equals: #different! !

!DSRightDifferentRectanglesTest methodsFor: 'list' stamp: 'HwaJong 10/28/2012 21:52'!
testListRowSize
self assert: s listRowSize equals: 4! !

!DSRightDifferentRectanglesTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 20:25'!
testOpenInnerDifferenceAtKey
| indi |
indi := (s openInnerDifferenceAtKey: 'corner').
self assert: indi comparisonResultInLiterals equals: #(#(#class #same) #('x' #different) #('y' #identical))! !

!DSRightDifferentRectanglesTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 17:01'!
testRightSideObjectOfListItemAtRow1
self assert: (s rightSideObjectOfListItemAtRow: 1) equals: (2@3 corner: 20@15).! !

!DSRightDifferentRectanglesTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 17:00'!
testRightSideObjectOfListItemAtRow2
self assert: (s rightSideObjectOfListItemAtRow: 2) equals: Rectangle! !

!DSRightDifferentRectanglesTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 17:00'!
testRightSideObjectOfListItemAtRow3
self assert: (s rightSideObjectOfListItemAtRow: 3) equals: (2@3)! !

!DSRightDifferentRectanglesTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 16:58'!
testRightSideObjectOfListItemAtRow4
self assert: (s rightSideObjectOfListItemAtRow: 4) equals: (20@15)! !

DiffSheetTest subclass: #DSRightShortStringTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff-Test'!

!DSRightShortStringTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 20:29'!
setUp
super setUp.
s leftSideObject: 'hello'.
s rightSideObject: 'hell'.
! !

!DSRightShortStringTest methodsFor: 'inner difference' stamp: 'HwaJong 10/31/2012 19:03'!
testCanOpenInnerDifferenceAtKeyIndex1
self deny: (s canOpenInnerDifferenceAtKeyIndex: 1)! !

!DSRightShortStringTest methodsFor: 'inner difference' stamp: 'HwaJong 10/31/2012 19:15'!
testCanOpenInnerDifferenceAtKeyIndex2
self deny: (s canOpenInnerDifferenceAtKeyIndex: 2)! !

!DSRightShortStringTest methodsFor: 'inner difference' stamp: 'HwaJong 10/31/2012 19:15'!
testCanOpenInnerDifferenceAtKeyIndex3
self deny: (s canOpenInnerDifferenceAtKeyIndex: 3)! !

!DSRightShortStringTest methodsFor: 'inner difference' stamp: 'HwaJong 10/31/2012 19:15'!
testCanOpenInnerDifferenceAtKeyIndex4
self deny: (s canOpenInnerDifferenceAtKeyIndex: 4)! !

!DSRightShortStringTest methodsFor: 'inner difference' stamp: 'HwaJong 10/31/2012 19:15'!
testCanOpenInnerDifferenceAtKeyIndex5
self deny: (s canOpenInnerDifferenceAtKeyIndex: 5)! !

!DSRightShortStringTest methodsFor: 'inner difference' stamp: 'HwaJong 10/31/2012 19:15'!
testCanOpenInnerDifferenceAtKeyIndex6
self deny: (s canOpenInnerDifferenceAtKeyIndex: 6)! !

!DSRightShortStringTest methodsFor: 'inner difference' stamp: 'HwaJong 10/31/2012 19:15'!
testCanOpenInnerDifferenceAtKeyIndex7
self deny: (s canOpenInnerDifferenceAtKeyIndex: 7)! !

!DSRightShortStringTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 19:33'!
testCanOpenInspectorLeft1
self assert: (s canOpenLeftInspectorAtRowIndex: 1)! !

!DSRightShortStringTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 19:45'!
testCanOpenInspectorLeft2
self assert: (s canOpenLeftInspectorAtRowIndex: 2)! !

!DSRightShortStringTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 19:45'!
testCanOpenInspectorLeft3
self assert: (s canOpenLeftInspectorAtRowIndex: 3)! !

!DSRightShortStringTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 19:45'!
testCanOpenInspectorLeft7
self assert: (s canOpenLeftInspectorAtRowIndex: 7)! !

!DSRightShortStringTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 21:17'!
testCanOpenInspectorRight1
self assert: (s canOpenRightInspectorAtRowIndex: 1)! !

!DSRightShortStringTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 21:17'!
testCanOpenInspectorRight2
self assert: (s canOpenRightInspectorAtRowIndex: 2)! !

!DSRightShortStringTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 21:17'!
testCanOpenInspectorRight3
self assert: (s canOpenRightInspectorAtRowIndex: 3)! !

!DSRightShortStringTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 21:18'!
testCanOpenInspectorRight7
self deny: (s canOpenRightInspectorAtRowIndex: 7)! !

!DSRightShortStringTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 20:29'!
testComparisonResultInLiterals
self assert: s comparisonResultInLiterals equals: #(#(#class #same) #(1 #identical) #(2 #identical) #(3 #identical) #(4 #identical) #(5 #rightMissing)) 
! !

!DSRightShortStringTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 15:15'!
testLeftSideObjectOfListItemAtRow1
self assert: (s leftSideObjectOfListItemAtRow: 1) equals: 'hello'! !

!DSRightShortStringTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 16:18'!
testLeftSideObjectOfListItemAtRow2
self assert: (s leftSideObjectOfListItemAtRow: 2) equals: ByteString! !

!DSRightShortStringTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 16:19'!
testLeftSideObjectOfListItemAtRow3
self assert: (s leftSideObjectOfListItemAtRow: 3) equals: $h! !

!DSRightShortStringTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 16:19'!
testLeftSideObjectOfListItemAtRow4
self assert: (s leftSideObjectOfListItemAtRow: 4) equals: $e! !

!DSRightShortStringTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 16:19'!
testLeftSideObjectOfListItemAtRow5
self assert: (s leftSideObjectOfListItemAtRow: 5) equals: $l! !

!DSRightShortStringTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 16:19'!
testLeftSideObjectOfListItemAtRow6
self assert: (s leftSideObjectOfListItemAtRow: 6) equals: $l! !

!DSRightShortStringTest methodsFor: 'list' stamp: 'HwaJong 10/30/2012 01:42'!
testListItemOfKeyAtRow1
self assert: (s listItemOfKeyAtRow: 1) equals: 'object'! !

!DSRightShortStringTest methodsFor: 'list' stamp: 'HwaJong 10/30/2012 01:41'!
testListItemOfKeyAtRow2
self assert: (s listItemOfKeyAtRow: 2) equals: 'class'! !

!DSRightShortStringTest methodsFor: 'list' stamp: 'HwaJong 10/30/2012 01:40'!
testListItemOfKeyAtRow3
self assert: (s listItemOfKeyAtRow: 3) equals: '1'! !

!DSRightShortStringTest methodsFor: 'list' stamp: 'HwaJong 10/30/2012 01:42'!
testListItemOfKeyAtRow4
self assert: (s listItemOfKeyAtRow: 4) equals: '2'! !

!DSRightShortStringTest methodsFor: 'list' stamp: 'HwaJong 10/30/2012 01:42'!
testListItemOfKeyAtRow5
self assert: (s listItemOfKeyAtRow: 5) equals: '3'! !

!DSRightShortStringTest methodsFor: 'list' stamp: 'HwaJong 10/30/2012 01:43'!
testListItemOfKeyAtRow6
self assert: (s listItemOfKeyAtRow: 6) equals: '4'! !

!DSRightShortStringTest methodsFor: 'list' stamp: 'HwaJong 10/30/2012 01:43'!
testListItemOfKeyAtRow7
self assert: (s listItemOfKeyAtRow: 7) equals: '5'! !

!DSRightShortStringTest methodsFor: 'list' stamp: 'HwaJong 10/30/2012 01:48'!
testListItemOfRightSideAtRow7
self assert: (s listItemOfRightSideAtRow: 7) equals: ''! !

!DSRightShortStringTest methodsFor: 'list' stamp: 'HwaJong 10/30/2012 01:51'!
testListItemOfTypeAtRow1
self assert: (s listItemOfTypeAtRow: 1) equals: #different! !

!DSRightShortStringTest methodsFor: 'list' stamp: 'HwaJong 10/30/2012 01:51'!
testListItemOfTypeAtRow2
self assert: (s listItemOfTypeAtRow: 2) equals: #identical! !

!DSRightShortStringTest methodsFor: 'list' stamp: 'HwaJong 10/30/2012 01:51'!
testListItemOfTypeAtRow3
self assert: (s listItemOfTypeAtRow: 3) equals: #identical! !

!DSRightShortStringTest methodsFor: 'list' stamp: 'HwaJong 10/30/2012 01:50'!
testListItemOfTypeAtRow4
self assert: (s listItemOfTypeAtRow: 4) equals: #identical! !

!DSRightShortStringTest methodsFor: 'list' stamp: 'HwaJong 10/30/2012 01:51'!
testListItemOfTypeAtRow5
self assert: (s listItemOfTypeAtRow: 5) equals: #identical! !

!DSRightShortStringTest methodsFor: 'list' stamp: 'HwaJong 10/30/2012 01:52'!
testListItemOfTypeAtRow6
self assert: (s listItemOfTypeAtRow: 6) equals: #identical! !

!DSRightShortStringTest methodsFor: 'list' stamp: 'HwaJong 10/30/2012 01:52'!
testListItemOfTypeAtRow7
self assert: (s listItemOfTypeAtRow: 7) equals: #rightMissing! !

!DSRightShortStringTest methodsFor: 'list' stamp: 'HwaJong 10/31/2012 18:49'!
testListRowSize
self assert: s listRowSize equals: 7! !

!DSRightShortStringTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 17:02'!
testRightSideObjectOfListItemAtRow1
self assert: (s rightSideObjectOfListItemAtRow: 1) equals: 'hell'! !

!DSRightShortStringTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 17:02'!
testRightSideObjectOfListItemAtRow2
self assert: (s rightSideObjectOfListItemAtRow: 2) equals: ByteString! !

!DSRightShortStringTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 17:02'!
testRightSideObjectOfListItemAtRow3
self assert: (s rightSideObjectOfListItemAtRow: 3) equals: $h! !

!DSRightShortStringTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 17:02'!
testRightSideObjectOfListItemAtRow4
self assert: (s rightSideObjectOfListItemAtRow: 4) equals: $e! !

!DSRightShortStringTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 17:03'!
testRightSideObjectOfListItemAtRow5
self assert: (s rightSideObjectOfListItemAtRow: 5) equals: $l! !

!DSRightShortStringTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 17:03'!
testRightSideObjectOfListItemAtRow6
self assert: (s rightSideObjectOfListItemAtRow: 6) equals: $l! !

DiffSheetTest subclass: #DSSameLengthStringsTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff-Test'!

!DSSameLengthStringsTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 20:26'!
setUp
super setUp.
s leftSideObject: 'hell'.
s rightSideObject: 'llll'.
! !

!DSSameLengthStringsTest methodsFor: 'inner difference' stamp: 'HwaJong 10/31/2012 19:04'!
testCanOpenInnerDifferenceAtKeyIndex1
self deny: (s canOpenInnerDifferenceAtKeyIndex: 1)! !

!DSSameLengthStringsTest methodsFor: 'inner difference' stamp: 'HwaJong 10/31/2012 19:16'!
testCanOpenInnerDifferenceAtKeyIndex2
self deny: (s canOpenInnerDifferenceAtKeyIndex: 2)! !

!DSSameLengthStringsTest methodsFor: 'inner difference' stamp: 'HwaJong 10/31/2012 19:17'!
testCanOpenInnerDifferenceAtKeyIndex3
self assert: (s canOpenInnerDifferenceAtKeyIndex: 3)! !

!DSSameLengthStringsTest methodsFor: 'inner difference' stamp: 'HwaJong 10/31/2012 19:17'!
testCanOpenInnerDifferenceAtKeyIndex4
self assert: (s canOpenInnerDifferenceAtKeyIndex: 4)! !

!DSSameLengthStringsTest methodsFor: 'inner difference' stamp: 'HwaJong 10/31/2012 19:17'!
testCanOpenInnerDifferenceAtKeyIndex5
self deny: (s canOpenInnerDifferenceAtKeyIndex: 5)! !

!DSSameLengthStringsTest methodsFor: 'inner difference' stamp: 'HwaJong 10/31/2012 19:17'!
testCanOpenInnerDifferenceAtKeyIndex6
self deny: (s canOpenInnerDifferenceAtKeyIndex: 6)! !

!DSSameLengthStringsTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 19:33'!
testCanOpenInspectorLeft1
self assert: (s canOpenLeftInspectorAtRowIndex: 1)! !

!DSSameLengthStringsTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 21:19'!
testCanOpenInspectorRight4
self assert: (s canOpenRightInspectorAtRowIndex: 4)! !

!DSSameLengthStringsTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 20:27'!
testComparisonResultInLiterals
self assert: s comparisonResultInLiterals equals: #(#(#class #same) #(1 #different) #(2 #different) #(3 #identical) #(4 #identical)) 
! !

!DSSameLengthStringsTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 15:15'!
testLeftSideObjectOfListItemAtRow1
self assert: (s leftSideObjectOfListItemAtRow: 1) equals: 'hell'! !

!DSSameLengthStringsTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 15:16'!
testLeftSideObjectOfListItemAtRow2
self assert: (s leftSideObjectOfListItemAtRow: 2) equals: ByteString! !

!DSSameLengthStringsTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 15:17'!
testLeftSideObjectOfListItemAtRow3
self assert: (s leftSideObjectOfListItemAtRow: 3) equals: $h! !

!DSSameLengthStringsTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 15:19'!
testLeftSideObjectOfListItemAtRow4
self assert: (s leftSideObjectOfListItemAtRow: 4) equals: $e! !

!DSSameLengthStringsTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 15:19'!
testLeftSideObjectOfListItemAtRow5
self assert: (s leftSideObjectOfListItemAtRow: 5) equals: $l! !

!DSSameLengthStringsTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 15:20'!
testLeftSideObjectOfListItemAtRow6
self assert: (s leftSideObjectOfListItemAtRow: 6) equals: $l! !

!DSSameLengthStringsTest methodsFor: 'list' stamp: 'HwaJong 10/30/2012 02:00'!
testListItemOfKeyAtRow1
self assert: (s listItemOfKeyAtRow: 1) equals: 'object'! !

!DSSameLengthStringsTest methodsFor: 'list' stamp: 'HwaJong 10/30/2012 02:00'!
testListItemOfKeyAtRow2
self assert: (s listItemOfKeyAtRow: 2) equals: 'class'! !

!DSSameLengthStringsTest methodsFor: 'list' stamp: 'HwaJong 10/30/2012 01:59'!
testListItemOfKeyAtRow3
self assert: (s listItemOfKeyAtRow: 3) equals: '1'! !

!DSSameLengthStringsTest methodsFor: 'list' stamp: 'HwaJong 10/30/2012 01:59'!
testListItemOfKeyAtRow4
self assert: (s listItemOfKeyAtRow: 4) equals: '2'! !

!DSSameLengthStringsTest methodsFor: 'list' stamp: 'HwaJong 10/30/2012 01:59'!
testListItemOfKeyAtRow5
self assert: (s listItemOfKeyAtRow: 5) equals: '3'! !

!DSSameLengthStringsTest methodsFor: 'list' stamp: 'HwaJong 10/30/2012 01:58'!
testListItemOfKeyAtRow6
self assert: (s listItemOfKeyAtRow: 6) equals: '4'! !

!DSSameLengthStringsTest methodsFor: 'list' stamp: 'HwaJong 10/30/2012 01:57'!
testListItemOfTypeAtRow1
self assert: (s listItemOfTypeAtRow: 1) equals: #different! !

!DSSameLengthStringsTest methodsFor: 'list' stamp: 'HwaJong 10/30/2012 01:57'!
testListItemOfTypeAtRow2
self assert: (s listItemOfTypeAtRow: 2) equals: #identical! !

!DSSameLengthStringsTest methodsFor: 'list' stamp: 'HwaJong 10/30/2012 01:57'!
testListItemOfTypeAtRow3
self assert: (s listItemOfTypeAtRow: 3) equals: #different! !

!DSSameLengthStringsTest methodsFor: 'list' stamp: 'HwaJong 10/30/2012 01:56'!
testListItemOfTypeAtRow4
self assert: (s listItemOfTypeAtRow: 4) equals: #different! !

!DSSameLengthStringsTest methodsFor: 'list' stamp: 'HwaJong 10/30/2012 01:56'!
testListItemOfTypeAtRow5
self assert: (s listItemOfTypeAtRow: 5) equals: #identical! !

!DSSameLengthStringsTest methodsFor: 'list' stamp: 'HwaJong 10/30/2012 01:57'!
testListItemOfTypeAtRow6
self assert: (s listItemOfTypeAtRow: 6) equals: #identical! !

!DSSameLengthStringsTest methodsFor: 'list' stamp: 'HwaJong 10/31/2012 18:48'!
testListRowSize
self assert: s listRowSize equals: 6! !

!DSSameLengthStringsTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 17:10'!
testRightSideObjectOfListItemAtRow1
self assert: (s rightSideObjectOfListItemAtRow: 1) equals: 'llll'! !

!DSSameLengthStringsTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 17:10'!
testRightSideObjectOfListItemAtRow2
self assert: (s rightSideObjectOfListItemAtRow: 2) equals: ByteString! !

!DSSameLengthStringsTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 17:10'!
testRightSideObjectOfListItemAtRow3
self assert: (s rightSideObjectOfListItemAtRow: 3) equals: $l! !

!DSSameLengthStringsTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 17:10'!
testRightSideObjectOfListItemAtRow4
self assert: (s rightSideObjectOfListItemAtRow: 4) equals: $l! !

!DSSameLengthStringsTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 17:11'!
testRightSideObjectOfListItemAtRow5
self assert: (s rightSideObjectOfListItemAtRow: 5) equals: $l! !

!DSSameLengthStringsTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 17:11'!
testRightSideObjectOfListItemAtRow6
self assert: (s rightSideObjectOfListItemAtRow: 6) equals: $l! !

!DiffSheetTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/30/2012 13:01'!
openGUI
(ObjectDiffGUI on: s) open.! !

!DiffSheetTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 16:59'!
setUp
super setUp.
s := DiffSheet new.! !

TestCase subclass: #ODSheetTest
	instanceVariableNames: 'sheet'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff-Sheet-Test'!

!ODSheetTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/13/2012 14:34'!
setUp
super setUp.
sheet := ODSheet new.
sheet objects: {'hello'. 19. World}.
sheet accesses: {[:o| o sizeInMemory]. [:o| o className]. [:o| o even]}.
! !

!ODSheetTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/13/2012 14:35'!
testValueAt1At1
self assert: (sheet valueOfObjectAt: 1 byAccessAt: 1) equals: 9! !

!ODSheetTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/13/2012 14:31'!
testValueAt1At2
self assert: (sheet valueOfObjectAt: 1 byAccessAt: 2) equals: 'ByteString'! !

!ODSheetTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/13/2012 14:29'!
testValueAt1At3
self assert: ((sheet valueOfObjectAt: 1 byAccessAt: 3) isKindOf: MessageNotUnderstood).! !

!ODSheetTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/13/2012 14:35'!
testValueAt2At1
self assert: (sheet valueOfObjectAt: 2 byAccessAt: 1) equals: 0! !

!ODSheetTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/13/2012 14:36'!
testValueAt2At2
self assert: (sheet valueOfObjectAt: 2 byAccessAt: 2) equals: 'SmallInteger'! !

!ODSheetTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/13/2012 14:39'!
testValueAt2At3
self deny: (sheet valueOfObjectAt: 2 byAccessAt: 3).! !

!ODSheetTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/13/2012 14:36'!
testValueAt3At1
self assert: (sheet valueOfObjectAt: 3 byAccessAt: 1) equals: 52! !

!ODSheetTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/13/2012 14:37'!
testValueAt3At2
self assert: (sheet valueOfObjectAt: 3 byAccessAt: 2) equals: 'PasteUpMorph'! !

!ODSheetTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/13/2012 14:39'!
testValueAt3At3
self assert: ((sheet valueOfObjectAt: 3 byAccessAt: 3) isKindOf: MessageNotUnderstood).! !

TestCase subclass: #ObjectDiffSystemTest
	instanceVariableNames: 'object'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff-System'!

ObjectDiffSystemTest subclass: #ODSArrayTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff-System'!

!ODSArrayTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 00:17'!
setUp
super setUp.
object := #(10 20 30 40).! !

!ODSArrayTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 00:06'!
testObjectDiffKeys
self assert: object objectDiffKeys equals: (1 to: 4)! !

!ODSArrayTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 00:19'!
testObjectDiffValueAt1
self assert: (object objectDiffValueAt: 1) equals: (10)! !

!ODSArrayTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 00:19'!
testObjectDiffValueAt2
self assert: (object objectDiffValueAt: 2) equals: (20)! !

!ODSArrayTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 00:19'!
testObjectDiffValueAt3
self assert: (object objectDiffValueAt: 3) equals: (30)! !

!ODSArrayTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 00:19'!
testObjectDiffValueAt4
self assert: (object objectDiffValueAt: 4) equals: (40)! !

ObjectDiffSystemTest subclass: #ODSDictionaryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff-System'!

!ODSDictionaryTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 00:06'!
setUp
super setUp.
object := Dictionary new.
object at: 'hello' put: 'kitty'.
object at: 30 put: 'thirty'.
! !

!ODSDictionaryTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 00:07'!
testObjectDiffKeys
self assert: object objectDiffKeys equals: {30. 'hello'}! !

!ODSDictionaryTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 00:22'!
testObjectDiffValueAt30
self assert: (object objectDiffValueAt: 30) equals: ('thirty')! !

!ODSDictionaryTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 00:21'!
testObjectDiffValueAtHello
self assert: (object objectDiffValueAt: 'hello') equals: ('kitty')! !

ObjectDiffSystemTest subclass: #ODSDomainErrorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff-System'!

!ODSDomainErrorTest commentStamp: 'HwaJong 10/31/2012 17:20' prior: 0!
test for accessing instance variables defined distinct classes of a hierarchy.!

!ODSDomainErrorTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/31/2012 17:19'!
setUp
super setUp.
object := DomainError new messageText: 'do better!!'; from: 10; to: 100.! !

!ODSDomainErrorTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/31/2012 17:16'!
testObjectDiffKeys
self assert: object objectDiffKeys equals: {'messageText'. 'tag'. 'signaler'. 'signalContext'. 'handlerContext'. 'outerContext'. 'from'. 'to'}! !

!ODSDomainErrorTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/31/2012 17:19'!
testObjectDiffValueAtFrom
self assert: (object objectDiffValueAt: 'from') equals: 10! !

!ODSDomainErrorTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/31/2012 17:18'!
testObjectDiffValueAtMessageText
self assert: (object objectDiffValueAt: 'messageText') equals: 'do better!!'! !

ObjectDiffSystemTest subclass: #ODSObjectTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff-System'!

!ODSObjectTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 00:07'!
setUp
super setUp.
object := (2@3) corner: (10@15).! !

!ODSObjectTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 00:08'!
testObjectDiffKeys
self assert: object objectDiffKeys equals: {'origin'. 'corner'}! !

!ODSObjectTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 00:27'!
testObjectDiffValueAtCorner
self assert: (object objectDiffValueAt: 'corner') equals: (10@15)! !

!ODSObjectTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 00:23'!
testObjectDiffValueAtOrigin
self assert: (object objectDiffValueAt: 'origin') equals: (2@3)! !

ObjectDiffSystemTest subclass: #ODSSetTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff-System'!

!ODSSetTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 00:09'!
setUp
super setUp.
object := Set new.
object add: 10.
object add: 'joy'.
! !

!ODSSetTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 00:09'!
testObjectDiffKeys 
self assert: object objectDiffKeys equals: (1 to: 2)! !

!ODSSetTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 00:30'!
testObjectDiffValueAt1
self assert: ({10. 'joy'} includes: (object objectDiffValueAt: 1))! !

!ODSSetTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 00:33'!
testObjectDiffValueAt2
self assert: ({10. 'joy'} includes: (object objectDiffValueAt: 2))! !

!ODSSetTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 00:34'!
testObjectDiffValueAtDiffers
self deny: ((object objectDiffValueAt: 1) = (object objectDiffValueAt: 2))! !

!SequenceableCollection methodsFor: '*ObjectDiff-System' stamp: 'HwaJong 10/27/2012 22:21'!
objectDiffKeys
^self isEmpty
	ifTrue: [Array new]
	ifFalse: [1 to: self size]! !

!SequenceableCollection methodsFor: '*ObjectDiff-System' stamp: 'HwaJong 10/28/2012 00:18'!
objectDiffValueAt: anInteger 
^self at: anInteger! !

Object subclass: #DiffSheet
	instanceVariableNames: 'leftSideObject rightSideObject'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff'!

!DiffSheet methodsFor: 'inner difference' stamp: 'HwaJong 10/28/2012 11:45'!
canOpenInnerDifferenceAtKey: anObject
^self comparisonResult canOpenInnerDifferenceAtKey: anObject
! !

!DiffSheet methodsFor: 'inner difference' stamp: 'HwaJong 10/31/2012 19:27'!
canOpenInnerDifferenceAtKeyIndex: anInteger
^self comparisonResult canOpenInnerDifferenceAtKeyIndex: anInteger! !

!DiffSheet methodsFor: 'inspecting' stamp: 'HwaJong 10/31/2012 19:37'!
canOpenLeftInspectorAtRowIndex: anInteger
^self comparisonResult canOpenLeftInspectorAtRowIndex: anInteger.! !

!DiffSheet methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/31/2012 20:59'!
canOpenRightInspectorAtRowIndex: anInteger 
^self comparisonResult canOpenRightInspectorAtRowIndex: anInteger ! !

!DiffSheet methodsFor: 'accessing' stamp: 'HwaJong 10/28/2012 01:46'!
commonKeys
|keySet|
keySet := Set new.
keySet addAll: leftSideObject objectDiffKeys.
keySet addAll: rightSideObject objectDiffKeys.
^keySet asArray! !

!DiffSheet methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/29/2012 23:53'!
comparisonResult
leftSideObject == rightSideObject ifTrue: [^KSIdentical new leftSideObject: leftSideObject; rightSideObject: rightSideObject].
leftSideObject = rightSideObject ifTrue: [^KSEqual new leftSideObject: leftSideObject; rightSideObject: rightSideObject].
^KSDifferenceInDetail leftSideObject: leftSideObject rightSideObject:  rightSideObject commonKeys: self commonKeys.
	! !

!DiffSheet methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 11:37'!
comparisonResultInLiterals
^self comparisonResult literalForm
	! !

!DiffSheet methodsFor: 'accessing' stamp: 'HwaJong 10/28/2012 01:44'!
leftSideObject: anObject
leftSideObject := anObject! !

!DiffSheet methodsFor: 'inspecting' stamp: 'HwaJong 10/31/2012 15:09'!
leftSideObjectOfListItemAtRow: anInteger 
^self comparisonResult leftSideObjectOfListItemAtRow: anInteger ! !

!DiffSheet methodsFor: 'list item' stamp: 'HwaJong 10/30/2012 12:07'!
listItemAtRow: anInteger 
^KSListItem diffSheet: self index: anInteger! !

!DiffSheet methodsFor: 'list item' stamp: 'HwaJong 10/30/2012 12:27'!
listItemOfKeyAtRow: aSmallInteger 
^(self listItemAtRow: aSmallInteger) diffKey.! !

!DiffSheet methodsFor: 'list item' stamp: 'HwaJong 10/30/2012 12:28'!
listItemOfLeftSideAtRow: aSmallInteger 
^(self listItemAtRow: aSmallInteger) diffLeftSidePrint.! !

!DiffSheet methodsFor: 'list item' stamp: 'HwaJong 10/30/2012 12:30'!
listItemOfRightSideAtRow: aSmallInteger 
^(self listItemAtRow: aSmallInteger) diffRightSidePrint.! !

!DiffSheet methodsFor: 'list item' stamp: 'HwaJong 10/30/2012 12:32'!
listItemOfTypeAtRow: aSmallInteger 
^(self listItemAtRow: aSmallInteger) diffItemType.! !

!DiffSheet methodsFor: 'list item' stamp: 'HwaJong 10/30/2012 12:06'!
listItems
^(1 to: self listRowSize) collect: [:index| self listItemAtRow: index]! !

!DiffSheet methodsFor: 'list item' stamp: 'HwaJong 10/28/2012 21:51'!
listRowSize
^self comparisonResult listRowSize.! !

!DiffSheet methodsFor: 'inner difference' stamp: 'HwaJong 10/28/2012 14:38'!
openInnerDifferenceAtKey: anObject 
^self class new
	leftSideObject: (leftSideObject objectDiffValueAt: anObject);
	rightSideObject: (rightSideObject objectDiffValueAt: anObject)! !

!DiffSheet methodsFor: 'inner difference' stamp: 'HwaJong 10/31/2012 11:43'!
openInnerDifferenceAtKeyIndex: aSmallInteger 
^self openInnerDifferenceAtKey: (self commonKeys at: aSmallInteger-2)! !

!DiffSheet methodsFor: 'accessing' stamp: 'HwaJong 10/28/2012 01:45'!
rightSideObject: anObject 
rightSideObject := anObject! !

!DiffSheet methodsFor: 'inspecting' stamp: 'HwaJong 10/31/2012 16:40'!
rightSideObjectOfListItemAtRow: anInteger 
^self comparisonResult rightSideObjectOfListItemAtRow: anInteger ! !

Object subclass: #FormCache
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff-GUI'!

FormCache class
	instanceVariableNames: 'TheFormThatCached'!

FormCache class
	instanceVariableNames: 'TheFormThatCached'!

!FormCache classSide methodsFor: 'accessing' stamp: 'HwaJong 10/31/2012 18:30'!
formThatCached
^TheFormThatCached setDefault: #defaultFormThatCached for: self withSetter: #formThatCached:! !

!FormCache classSide methodsFor: 'accessing' stamp: 'HwaJong 10/31/2012 18:30'!
formThatCached: aForm 
	TheFormThatCached := aForm! !

FormCache subclass: #ODDifferentIcon
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff-GUI'!

!ODDifferentIcon classSide methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/31/2012 18:30'!
defaultFormThatCached
^(Form
	extent: (16@16)
	depth: 32
	fromArray: #( 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 167772160 16777216 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 570425344 603979776 16777215 16777215 16777215 1107296256 1107296256 16777215 16777215 167772160 536870912 16777215 16777215 16777215 16777215 16777216 2147483648 251658240 16777215 16777215 16777215 167772160 2365587456 117440512 100663296 2583691264 872415232 16777215 16777215 16777215 16777215 1459617792 1476395008 1778384896 67108864 16777215 16777215 16777215 1275068416 1895825408 1946157056 1493172224 16777215 16777215 16777215 16777215 872415232 3036676096 1795162112 2533359616 1828716544 83886080 16777215 16777215 16777215 3137339392 3137339392 16777215 16777215 16777215 50331648 134217728 3271557120 2650800128 3741319168 3472883712 3674210304 2734686208 16777215 16777215 1392508928 2248146944 3338665984 2231369728 16777215 16777215 134217728 2634022912 3640655872 2952790016 3137339392 2181038080 3489660928 3204448256 2365587456 587202560 3187671040 251658240 218103808 3019898880 637534208 16777215 16777215 16777215 822083584 1828716544 2315255808 2298478592 2415919104 184549376 16777215 520093696 905969664 16777215 16777215 201326592 268435456 16777215 16777215 16777215 16777215 16777215 16777215 67108864 83886080 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215)
	offset: (0@0))! !

FormCache subclass: #ODEqualIcon
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff-GUI'!

!ODEqualIcon classSide methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/31/2012 18:30'!
defaultFormThatCached
^(Form
	extent: (16@16)
	depth: 32
	fromArray: #( 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 83886080 838860800 117440512 16777215 16777215 16777215 16777215 16777215 83886080 838860800 117440512 16777215 16777215 16777215 16777215 1493172224 3372220416 3355443200 3187671040 16777215 16777215 16777215 16777215 1493172224 3372220416 3355443200 3187671040 16777215 16777215 16777215 2181038080 3808428032 3422552064 1308622848 2835349504 1174405120 16777215 16777215 2181038080 3808428032 3422552064 1308622848 2835349504 1174405120 16777215 117440512 2734686208 2868903936 4026531840 4177526784 2751463424 1644167168 16777215 117440512 2734686208 2868903936 4026531840 4177526784 2751463424 1644167168 16777215 167772160 3170893824 2013265920 4143972352 3841982464 3472883712 1946157056 16777215 167772160 3170893824 2013265920 4143972352 3841982464 3472883712 1946157056 16777215 1073741824 3170893824 2147483648 4043309056 3573547008 3472883712 2063597568 16777215 1073741824 3170893824 2147483648 4043309056 3573547008 3472883712 2063597568 16777215 1207959552 2667577344 2600468480 3909091328 3271557120 2952790016 2566914048 16777215 1207959552 2667577344 2600468480 3909091328 3271557120 2952790016 2566914048 16777215 855638016 2533359616 2768240640 2634022912 3724541952 3019898880 2583691264 16777215 855638016 2533359616 2768240640 2634022912 3724541952 3019898880 2583691264 16777215 973078528 3036676096 2533359616 2080374784 4026531840 3355443200 2566914048 16777215 973078528 3036676096 2533359616 2080374784 4026531840 3355443200 2566914048 16777215 469762048 2717908992 2617245696 1895825408 3875536896 3221225472 1946157056 16777215 469762048 2717908992 2617245696 1895825408 3875536896 3221225472 1946157056 16777215 134217728 2734686208 2868903936 2650800128 3321888768 3036676096 2113929216 16777215 134217728 2734686208 2868903936 2650800128 3321888768 3036676096 2113929216 16777215 16777215 2868903936 1056964608 3053453312 3154116608 2701131776 1778384896 16777215 16777215 2868903936 1056964608 3053453312 3154116608 2701131776 1778384896 16777215 16777215 1879048192 1795162112 654311424 2533359616 2936012800 318767104 16777215 16777215 1879048192 1795162112 654311424 2533359616 2936012800 318767104 16777215 16777215 33554432 1728053248 3003121664 2667577344 268435456 16777215 16777215 16777215 33554432 1728053248 3003121664 2667577344 268435456 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215)
	offset: (0@0)).! !

FormCache subclass: #ODIdenticalIcon
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff-GUI'!

!ODIdenticalIcon classSide methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/31/2012 18:30'!
defaultFormThatCached
^(Form
	extent: (16@16)
	depth: 32
	fromArray: #( 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 83886080 838860800 117440512 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 1493172224 3372220416 3355443200 3187671040 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 2181038080 3808428032 3422552064 1308622848 2835349504 1174405120 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 117440512 2734686208 2868903936 4026531840 4177526784 2751463424 1644167168 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 167772160 3170893824 2013265920 4143972352 3841982464 3472883712 1946157056 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 1073741824 3170893824 2147483648 4043309056 3573547008 3472883712 2063597568 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 1207959552 2667577344 2600468480 3909091328 3271557120 2952790016 2566914048 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 855638016 2533359616 2768240640 2634022912 3724541952 3019898880 2583691264 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 973078528 3036676096 2533359616 2080374784 4026531840 3355443200 2566914048 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 469762048 2717908992 2617245696 1895825408 3875536896 3221225472 1946157056 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 134217728 2734686208 2868903936 2650800128 3321888768 3036676096 2113929216 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 2868903936 1056964608 3053453312 3154116608 2701131776 1778384896 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 1879048192 1795162112 654311424 2533359616 2936012800 318767104 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 33554432 1728053248 3003121664 2667577344 268435456 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215)
	offset: (0@0))! !

FormCache subclass: #ODLeftMissingIcon
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff-GUI'!

!ODLeftMissingIcon classSide methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/31/2012 18:30'!
defaultFormThatCached
^(Form
	extent: (16@16)
	depth: 32
	fromArray: #( 16777215 67108864 184549376 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 536870912 1526726656 16777215 520093696 1493172224 184549376 16777215 16777215 16777215 16777215 335544320 335544320 16777215 16777215 16777215 16777215 788529152 2432696320 16777215 167772160 1610612736 2499805184 402653184 16777215 16777215 318767104 3506438144 3439329280 2902458368 83886080 16777215 16777215 1040187392 2684354560 16777215 16777215 16777215 117440512 150994944 16777215 16777215 2214592512 3489660928 771751936 3321888768 1157627904 16777215 16777215 469762048 855638016 16777215 16777215 16777215 16777215 16777215 16777215 16777216 3204448256 2969567232 2332033024 3523215360 2550136832 16777215 16777215 67108864 167772160 16777215 16777215 16777215 184549376 150994944 16777215 16777215 2785017856 2013265920 3070230528 3539992576 2399141888 16777215 16777215 738197504 1929379840 16777215 16777215 16777215 1157627904 1996488704 16777215 16777215 2298478592 2432696320 3221225472 2499805184 2013265920 16777215 16777215 905969664 2483027968 16777215 16777215 16777215 1728053248 2785017856 16777215 16777215 2231369728 2801795072 2986344448 2181038080 2466250752 16777215 16777215 1157627904 1258291200 16777215 16777215 16777215 1174405120 1560281088 16777215 16777215 2818572288 3288334336 3573547008 3690987520 2634022912 16777215 16777215 754974720 687865856 16777215 16777215 16777215 100663296 100663296 16777215 16777215 3120562176 3741319168 4060086272 3858759680 2583691264 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 2432696320 3758096384 4110417920 3741319168 2717908992 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777216 3271557120 3892314112 3774873600 3338665984 2667577344 16777215 16777215 16777215 184549376 16777215 16777215 16777215 83886080 16777216 16777215 16777215 2902458368 1224736768 1979711488 3288334336 1426063360 16777215 16777215 16777215 1476395008 1962934272 16777215 16777215 1962934272 872415232 16777215 16777215 2415919104 973078528 1744830464 2348810240 536870912 16777215 16777215 16777215 50331648 1996488704 587202560 16777215 3187671040 251658240 16777215 16777215 1711276032 3271557120 2734686208 2130706432 16777215 16777215 16777215 16777215 16777215 16777215 16777215 268435456 1543503872 16777215 16777215 16777215 50331648 1744830464 2332033024 50331648 16777215 16777215)
	offset: (0@0)).! !

FormCache subclass: #ODRightMissingIcon
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff-GUI'!

!ODRightMissingIcon classSide methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/31/2012 18:30'!
defaultFormThatCached
^(Form
	extent: (16@16)
	depth: 32
	fromArray: #( 16777215 16777215 16777215 33554432 16777215 16777215 16777215 16777215 16777215 16777215 16777215 922746880 1795162112 167772160 16777215 16777215 16777215 16777215 218103808 2734686208 3238002688 721420288 16777215 16777215 16777215 16777215 16777215 335544320 2046820352 939524096 16777215 16777215 16777215 16777215 1090519040 3238002688 2701131776 3271557120 335544320 16777215 16777215 16777215 184549376 16777215 16777215 16777215 16777215 16777215 16777215 16777215 1174405120 3992977408 3305111552 3254779904 1526726656 16777215 16777215 16777215 1761607680 134217728 16777215 16777215 83886080 50331648 16777215 16777215 2415919104 4110417920 3456106496 3187671040 2667577344 16777215 16777215 16777215 1409286144 50331648 16777215 16777215 1258291200 1090519040 16777215 16777215 3388997632 3976200192 3623878656 3305111552 2902458368 16777215 16777215 16777215 570425344 989855744 16777215 16777215 1459617792 1660944384 16777215 16777215 3523215360 3590324224 3657433088 3791650816 2785017856 16777216 16777215 16777215 939524096 1744830464 16777215 16777215 150994944 285212672 16777215 16777215 3288334336 3338665984 3607101440 3909091328 2801795072 16777215 16777215 16777215 503316480 1090519040 16777215 16777215 16777215 16777215 16777215 16777215 3003121664 3573547008 3791650816 3808428032 2919235584 16777215 16777215 16777215 16777216 150994944 16777215 16777215 16777215 16777215 16777215 16777216 2902458368 3388997632 3992977408 3137339392 3305111552 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777216 16777215 285212672 2785017856 3204448256 4110417920 2617245696 3556769792 16777215 16777215 16777215 201326592 369098752 16777215 16777215 503316480 989855744 16777215 335544320 2248146944 3992977408 4177526784 3254779904 3523215360 134217728 16777215 16777215 704643072 1342177280 16777215 16777215 855638016 1996488704 16777215 67108864 251658240 4060086272 3976200192 1577058304 3087007744 83886080 16777215 16777215 335544320 771751936 16777215 16777215 469762048 1140850688 16777215 16777215 16777215 3791650816 3321888768 3019898880 503316480 16777215 16777215 16777215 16777215 16777215 16777215 16777215 335544320 16777215 16777215 16777215 16777215 2785017856 2432696320 452984832 16777215 16777215 16777215 16777215 16777216 704643072 1325400064 150994944 318767104 16777215 16777215 16777215 16777215 385875968 16777216 33554432 16777215 16777215 16777215 16777215 16777215 520093696 1291845632 184549376 16777215 16777215)
	offset: (0@0)).! !

Object subclass: #KSComparison
	instanceVariableNames: 'leftSideObject rightSideObject'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff'!

KSComparison subclass: #KSClassComparison
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff'!

!KSClassComparison methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/31/2012 17:50'!
diffLeftSidePrint
^self leftSideObjectOfListItem printString! !

!KSClassComparison methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/31/2012 17:50'!
diffRightSidePrint
^self rightSideObjectOfListItem printString ! !

!KSClassComparison methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/31/2012 17:49'!
leftSideObjectOfListItem
^leftSideObject class! !

!KSClassComparison methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/31/2012 17:49'!
rightSideObjectOfListItem
^rightSideObject class ! !

KSClassComparison subclass: #KSDifferentClass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff'!

!KSDifferentClass methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/31/2012 19:12'!
canOpenInnerDifference
^true! !

!KSDifferentClass methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/30/2012 03:11'!
diffItemType
^#different! !

!KSDifferentClass methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 12:32'!
literalForm
^{#class. #different}! !

KSClassComparison subclass: #KSSameClass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff'!

!KSSameClass methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/31/2012 19:06'!
canOpenInnerDifference
^false! !

!KSSameClass methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/30/2012 01:21'!
diffItemType
^#identical! !

!KSSameClass methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 10:29'!
literalForm
^{#class. #same}! !

!KSComparison classSide methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/30/2012 01:04'!
leftSideObject: object1 rightSideObject: object2 
^self new
	leftSideObject: object1;
	rightSideObject: object2 ! !

!KSComparison methodsFor: 'accessing' stamp: 'HwaJong 10/29/2012 23:49'!
leftSideObject
^leftSideObject! !

!KSComparison methodsFor: 'accessing' stamp: 'HwaJong 10/29/2012 23:48'!
leftSideObject: anObject 
leftSideObject := anObject ! !

!KSComparison methodsFor: 'accessing' stamp: 'HwaJong 10/29/2012 23:49'!
rightSideObject
^rightSideObject! !

!KSComparison methodsFor: 'accessing' stamp: 'HwaJong 10/29/2012 23:48'!
rightSideObject: anObject 
rightSideObject := anObject ! !

KSComparison subclass: #KSInsideComparison
	instanceVariableNames: 'key'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff'!

!KSInsideComparison classSide methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 12:19'!
leftSideObject: object1 rightSideObject: object2 key: key 
|properClass|
properClass := (object1 objectDiffHasKey: key) ifTrue: [ (object2 objectDiffHasKey: key) ifTrue: [|partLeft partRight| partLeft := object1 objectDiffValueAt: key. partRight := object2 objectDiffValueAt: key.(partLeft==partRight ifTrue: [KSPartIdentical ] ifFalse: [partLeft=partRight ifTrue: [KSPartEqual ] ifFalse: [KSPartDifferent ]])] ifFalse: [KSRightPartMissing ]] ifFalse: [KSLeftPartMissing ].

^properClass new
	leftSideObject: object1;
	rightSideObject: object2;
	key: key! !

!KSInsideComparison methodsFor: 'testing' stamp: 'HwaJong 10/31/2012 19:50'!
canOpenLeftInspector
^true! !

!KSInsideComparison methodsFor: 'testing' stamp: 'HwaJong 10/31/2012 21:24'!
canOpenRightInspector
^true! !

!KSInsideComparison methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/31/2012 17:52'!
diffLeftSidePrint
	^ self leftSideObjectOfListItem printString! !

!KSInsideComparison methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/31/2012 17:52'!
diffRightSidePrint
	^ self rightSideObjectOfListItem printString! !

!KSInsideComparison methodsFor: 'accessing' stamp: 'HwaJong 10/28/2012 13:34'!
key

	^ key! !

!KSInsideComparison methodsFor: 'accessing' stamp: 'HwaJong 10/28/2012 14:27'!
key: anObject 
key := anObject ! !

!KSInsideComparison methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/31/2012 17:51'!
leftSideObjectOfListItem
^leftSideObject objectDiffValueAt: key! !

!KSInsideComparison methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 14:19'!
literalForm
^{key. self insideComparisonLiteral}! !

!KSInsideComparison methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/31/2012 17:51'!
rightSideObjectOfListItem
^rightSideObject objectDiffValueAt: key ! !

KSInsideComparison subclass: #KSPartBothPresent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff'!

KSPartBothPresent subclass: #KSPartDifferent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff'!

!KSPartDifferent methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 12:28'!
canOpenInnerDifference
^true! !

!KSPartDifferent methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/30/2012 01:37'!
diffItemType
^#different! !

!KSPartDifferent methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 14:20'!
insideComparisonLiteral
^#different! !

KSPartBothPresent subclass: #KSPartEqual
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff'!

!KSPartEqual methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 12:27'!
canOpenInnerDifference
^false! !

!KSPartEqual methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/30/2012 01:36'!
diffItemType
^#equal! !

!KSPartEqual methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 14:21'!
insideComparisonLiteral
^#equal! !

KSPartBothPresent subclass: #KSPartIdentical
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff'!

!KSPartIdentical methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/31/2012 12:16'!
canOpenInnerDifference
^false! !

!KSPartIdentical methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/30/2012 01:22'!
diffItemType
^#identical! !

!KSPartIdentical methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 14:21'!
insideComparisonLiteral
^#identical! !

KSInsideComparison subclass: #KSPartMissing
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff'!

KSPartMissing subclass: #KSLeftPartMissing
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff'!

!KSLeftPartMissing methodsFor: 'testing' stamp: 'HwaJong 10/31/2012 19:39'!
canOpenLeftInspector
^false! !

!KSLeftPartMissing methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/30/2012 01:23'!
diffItemType
^#leftMissing! !

!KSLeftPartMissing methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/30/2012 01:09'!
diffLeftSidePrint
^''! !

!KSLeftPartMissing methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 14:19'!
insideComparisonLiteral
^#leftMissing! !

!KSPartMissing methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/31/2012 18:39'!
canOpenInnerDifference
^false! !

KSPartMissing subclass: #KSRightPartMissing
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff'!

!KSRightPartMissing methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/31/2012 21:07'!
canOpenRightInspector
^false! !

!KSRightPartMissing methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/30/2012 01:52'!
diffItemType
^#rightMissing! !

!KSRightPartMissing methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/30/2012 01:48'!
diffRightSidePrint
^''! !

!KSRightPartMissing methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 14:22'!
insideComparisonLiteral
^#rightMissing! !

KSComparison subclass: #KSWholeComparison
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff'!

KSWholeComparison subclass: #KSDifferenceInDetail
	instanceVariableNames: 'classComparison insideComparisons'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff'!

!KSDifferenceInDetail classSide methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/30/2012 03:07'!
leftSideObject: object1 rightSideObject: object2 commonKeys: anArray 
^self new
	leftSideObject: object1;
	rightSideObject: object2;
	classComparison: (object1 class = object2 class ifTrue: [KSSameClass leftSideObject: object1 rightSideObject: object2] ifFalse: [KSDifferentClass leftSideObject: object1 rightSideObject: object2]);
	insideComparisons: (anArray collect: [:key| (KSInsideComparison leftSideObject: object1 rightSideObject: object2 key: key)])
! !

!KSDifferenceInDetail methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 12:14'!
canOpenInnerDifference
^insideComparisons anySatisfy: [:each| each canOpenInnerDifference ] ! !

!KSDifferenceInDetail methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 12:34'!
canOpenInnerDifferenceAtKey: aByteString 
^(insideComparisons detect: [:each| each key = aByteString]) canOpenInnerDifference! !

!KSDifferenceInDetail methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/31/2012 19:08'!
canOpenInnerDifferenceAtKeyIndex: aSmallInteger 
^self comparisonItemAt: aSmallInteger ifOne: [false]  ifTwo: [classComparison canOpenInnerDifference] ifElse: [:in| in canOpenInnerDifference]
! !

!KSDifferenceInDetail methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/31/2012 19:38'!
canOpenLeftInspectorAtRowIndex: aSmallInteger 
^self comparisonItemAt: aSmallInteger ifOne: [true] ifTwo: [true] ifElse: [:in| in canOpenLeftInspector]! !

!KSDifferenceInDetail methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/31/2012 21:03'!
canOpenRightInspectorAtRowIndex: aSmallInteger 
^self comparisonItemAt: aSmallInteger ifOne: [true] ifTwo: [true] ifElse: [:in| in canOpenRightInspector]! !

!KSDifferenceInDetail methodsFor: 'accessing' stamp: 'HwaJong 10/28/2012 12:00'!
classComparison: anObject
 classComparison := anObject
! !

!KSDifferenceInDetail methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/30/2012 02:22'!
comparisonItemAt: anInteger ifOne: block1 ifTwo: block2 ifElse: block3
anInteger = 1 ifTrue: [^block1 value].
anInteger = 2 ifTrue: [^block2 value].
^block3 value: (insideComparisons at: (anInteger-2))! !

!KSDifferenceInDetail methodsFor: 'accessing' stamp: 'HwaJong 10/28/2012 12:00'!
insideComparisons: anArray 
insideComparisons := anArray ! !

!KSDifferenceInDetail methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/31/2012 15:18'!
leftSideObjectOfListItemAtRow: aSmallInteger 
^self comparisonItemAt: aSmallInteger ifOne: [leftSideObject] ifTwo: [classComparison leftSideObjectOfListItem] ifElse: [:in| in leftSideObjectOfListItem]! !

!KSDifferenceInDetail methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/30/2012 02:22'!
listItemOfKeyAtRow: anInteger 
^self comparisonItemAt: anInteger 
	ifOne: ['object'] 
	ifTwo: ['class'] 
	ifElse: [:in| in key asString].! !

!KSDifferenceInDetail methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/30/2012 02:22'!
listItemOfLeftSideAtRow: anInteger 
^self comparisonItemAt: anInteger 
	ifOne: [leftSideObject printString] 
	ifTwo: [classComparison diffLeftSidePrint] 
	ifElse: [:in| in diffLeftSidePrint].! !

!KSDifferenceInDetail methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/30/2012 02:22'!
listItemOfRightSideAtRow: anInteger 
^self comparisonItemAt: anInteger 
	ifOne: [rightSideObject printString] 
	ifTwo: [classComparison diffRightSidePrint] 
	ifElse: [:in| in diffRightSidePrint].! !

!KSDifferenceInDetail methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/30/2012 02:23'!
listItemOfTypeAtRow: anInteger 
^self comparisonItemAt: anInteger 
	ifOne: [#different] 
	ifTwo: [classComparison diffItemType] 
	ifElse: [:in| in diffItemType].! !

!KSDifferenceInDetail methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 21:51'!
listRowSize
^1+1+insideComparisons size! !

!KSDifferenceInDetail methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 12:13'!
literalForm
^Array streamContents: [:stream| stream nextPut: classComparison literalForm; nextPutAll: insideComparisons literalForm]! !

!KSDifferenceInDetail methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/31/2012 17:44'!
rightSideObjectOfListItemAtRow: aSmallInteger 
^self comparisonItemAt: aSmallInteger ifOne: [rightSideObject]  ifTwo: [classComparison rightSideObjectOfListItem]  ifElse: [:in| in rightSideObjectOfListItem]! !

KSWholeComparison subclass: #KSSame
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff'!

KSSame subclass: #KSEqual
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff'!

!KSEqual methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/31/2012 15:10'!
leftSideObjectOfListItemAtRow: anInteger 
^leftSideObject! !

!KSEqual methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/30/2012 00:26'!
listItemOfTypeAtRow: aSmallInteger 
^'equal'! !

!KSEqual methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 10:23'!
literalForm
^#equal! !

!KSEqual methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/31/2012 17:54'!
rightSideObjectOfListItemAtRow: aSmallInteger 
^rightSideObject! !

KSSame subclass: #KSIdentical
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff'!

!KSIdentical methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/31/2012 15:10'!
leftSideObjectOfListItemAtRow: aSmallInteger 
^leftSideObject! !

!KSIdentical methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/30/2012 00:38'!
listItemOfTypeAtRow: aSmallInteger 
^#identical! !

!KSIdentical methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 10:20'!
literalForm
^#identical! !

!KSIdentical methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/31/2012 16:41'!
rightSideObjectOfListItemAtRow: aSmallInteger 
^rightSideObject! !

!KSSame methodsFor: 'testing' stamp: 'HwaJong 10/30/2012 02:35'!
canOpenInnerDifference
^false! !

!KSSame methodsFor: 'testing' stamp: 'HwaJong 10/30/2012 02:35'!
canOpenInnerDifferenceAtKey: anObject 
^false! !

!KSSame methodsFor: 'testing' stamp: 'HwaJong 10/31/2012 18:59'!
canOpenInnerDifferenceAtKeyIndex: anInteger 
^false! !

!KSSame methodsFor: 'testing' stamp: 'HwaJong 10/31/2012 19:37'!
canOpenLeftInspectorAtRowIndex: aSmallInteger 
^true! !

!KSSame methodsFor: 'testing' stamp: 'HwaJong 10/31/2012 21:20'!
canOpenRightInspectorAtRowIndex: aSmallInteger 
^true! !

!KSSame methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/30/2012 02:36'!
listItemOfKeyAtRow: one 
[one = 1] assert.
^'object'! !

!KSSame methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/30/2012 02:36'!
listRowSize
^1! !

!KSWholeComparison methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/30/2012 02:30'!
listItemOfLeftSideAtRow: aSmallInteger 
^leftSideObject printString! !

!KSWholeComparison methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/30/2012 02:31'!
listItemOfRightSideAtRow: aSmallInteger 
^rightSideObject printString ! !

Object subclass: #KSListItem
	instanceVariableNames: 'diffSheet index'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff'!

!KSListItem classSide methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/30/2012 12:08'!
diffSheet: aDiffSheet index: aSmallInteger 
^self new
	diffSheet: aDiffSheet;
	index: aSmallInteger! !

!KSListItem methodsFor: 'item text' stamp: 'HwaJong 10/31/2012 12:27'!
balloonText
^String streamContents: [:stream| 
	stream nextPutAll: self diffKey.
	stream nextPut: $:.
	stream cr;tab.
	stream nextPutAll: self diffLeftSidePrint.
	stream cr;tab.
	stream nextPutAll: self diffRightSidePrint].! !

!KSListItem methodsFor: 'testing' stamp: 'HwaJong 10/31/2012 12:14'!
canOpenInnerDifference
^diffSheet canOpenInnerDifferenceAtKeyIndex: index! !

!KSListItem methodsFor: 'testing' stamp: 'HwaJong 10/31/2012 19:27'!
canOpenLeftInspector
^diffSheet canOpenLeftInspectorAtRowIndex: index! !

!KSListItem methodsFor: 'list view protocol' stamp: 'HwaJong 10/30/2012 12:31'!
diffItemType
^diffSheet comparisonResult listItemOfTypeAtRow: index.! !

!KSListItem methodsFor: 'list view protocol' stamp: 'HwaJong 10/30/2012 12:14'!
diffKey
^diffSheet comparisonResult listItemOfKeyAtRow: index! !

!KSListItem methodsFor: 'list view protocol' stamp: 'HwaJong 10/30/2012 12:28'!
diffLeftSidePrint
^diffSheet comparisonResult listItemOfLeftSideAtRow: index! !

!KSListItem methodsFor: 'list view protocol' stamp: 'HwaJong 10/30/2012 12:30'!
diffRightSidePrint
^diffSheet comparisonResult listItemOfRightSideAtRow: index! !

!KSListItem methodsFor: 'accessing' stamp: 'HwaJong 10/30/2012 12:08'!
diffSheet: aDiffSheet 
diffSheet := aDiffSheet ! !

!KSListItem methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/30/2012 13:11'!
ifIdentical: aBlockClosure ifEqual: aBlockClosure2 ifDifferent: aBlockClosure3 ifLeftMissing: aBlockClosure4 ifRightMissing: aBlockClosure5 
|type|
type := diffSheet listItemOfTypeAtRow: index.
^type = #different
	ifTrue: [aBlockClosure3 value]
	ifFalse: [type = #identical
		ifTrue: [aBlockClosure value]
		ifFalse: [type = #equal
			ifTrue: [aBlockClosure2 value]
			ifFalse: [type = #leftMissing
				ifTrue: [aBlockClosure4 value] 
				ifFalse: [type = #rightMissing
					ifTrue: [aBlockClosure5 value]
					ifFalse: [self shouldBeImplemented]]]]]! !

!KSListItem methodsFor: 'accessing' stamp: 'HwaJong 10/30/2012 12:08'!
index: aSmallInteger 
index := aSmallInteger ! !

!KSListItem methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/31/2012 11:45'!
innerDifference
^diffSheet openInnerDifferenceAtKeyIndex: index! !

!KSListItem methodsFor: 'item text' stamp: 'HwaJong 10/30/2012 12:35'!
oneColumnPrintString
^String streamContents: [:stream| 
	stream nextPutAll: self diffKey.
	stream nextPut: $:.
	stream space.
	stream nextPutAll: self diffLeftSidePrint.
	stream nextPutAll: ' vs '.
	stream nextPutAll: self diffRightSidePrint].! !

Object subclass: #ODAccess
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff-Sheet'!

Object subclass: #ODSheet
	instanceVariableNames: 'objects accesses'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff-Sheet'!

!ODSheet methodsFor: 'accessing' stamp: 'HwaJong 10/13/2012 14:19'!
accesses
	^ accesses! !

!ODSheet methodsFor: 'accessing' stamp: 'HwaJong 10/13/2012 14:19'!
accesses: anArray
	accesses := anArray
! !

!ODSheet methodsFor: 'accessing' stamp: 'HwaJong 10/13/2012 14:19'!
objects
	^ objects! !

!ODSheet methodsFor: 'accessing' stamp: 'HwaJong 10/13/2012 14:19'!
objects: anArray
	objects := anArray
! !

!ODSheet methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/13/2012 14:25'!
valueOfObjectAt: objectIndex byAccessAt: accessIndex
|object access|
object := objects at: objectIndex.
access := accesses at: accessIndex.
^[access value: object] on: Error do: [:ex| ex]
! !

Object subclass: #ODWorkspace
	instanceVariableNames: 'sheet cellExtent contents win'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff-Sheet-GUI'!

!ODWorkspace methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/13/2012 18:19'!
cellMorphAtRow: rowIndex atColumn: colIndex
|cellObject morph|
cellObject := 
rowIndex = 0
	ifTrue: 
		[colIndex = 0
			ifTrue: ['objects'] 
			ifFalse: [sheet accesses at: colIndex]]
	ifFalse: 
		[colIndex = 0
			ifTrue: [sheet objects at: rowIndex]
			ifFalse: [sheet valueOfObjectAt: rowIndex byAccessAt: colIndex]].
morph := cellObject printString asMorph.
morph extent: cellExtent.
^morph! !

!ODWorkspace methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/13/2012 18:53'!
construct

self makeSheet.

cellExtent := 200@40.

contents := 
UITheme builder newColumn: 
	(Array streamContents: 
		[:rowStream|	
		0 to: sheet objects size do: 
			[:objectIndex|
			rowStream nextPut: 
				(UITheme builder newRow: 
					(Array streamContents: 
						[:stream|
						0 to: sheet accesses size do: 
							[:accessIndex|
							stream nextPut: (self cellMorphAtRow: objectIndex  atColumn: accessIndex)
							]
						])).
			]
]).! !

!ODWorkspace methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/13/2012 15:24'!
makeSheet
sheet := ODSheet new.
sheet objects: {'hello'. 19. World}.
sheet accesses: {[:o| o sizeInMemory]. [:o| o className]. [:o| o even]}.
! !

!ODWorkspace methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/30/2012 02:48'!
openWindow
win := contents openInWindowLabeled: 'SHEET'.! !

!Object methodsFor: '*ObjectDiff' stamp: 'HwaJong 10/3/2012 10:48'!
diff: anObject 
|obj1 obj2 pr|
obj1 := self.
obj2 := anObject.

pr:= [:obj| obj className, String cr, (obj longPrintStringLimitedTo: 20000)].
(DiffMorph new from: (pr value:obj1) to: (pr value:obj2)) openInWindowLabeled: obj1 printString, ' vs ', obj2 printString.
! !

!Object methodsFor: '*ObjectDiff' stamp: 'HwaJong 10/31/2012 00:16'!
diffyDiff: anObject
|d|
d := DiffSheet new.
d leftSideObject: self.
d rightSideObject: anObject.
(ObjectDiffGUI on: d) open.! !

!Object methodsFor: '*ObjectDiff' stamp: 'HwaJong 10/28/2012 21:08'!
listItemText
^self printString! !

!Object methodsFor: '*ObjectDiff-System' stamp: 'HwaJong 10/28/2012 02:29'!
objectDiffHasKey: anObject
^self objectDiffKeys includes: anObject ! !

!Object methodsFor: '*ObjectDiff-System' stamp: 'HwaJong 10/31/2012 00:35'!
objectDiffKeys
^self class allInstVarNames.! !

!Object methodsFor: '*ObjectDiff-System' stamp: 'HwaJong 10/31/2012 00:36'!
objectDiffValueAt: aString 
^self instVarAt: (self class allInstVarNames indexOf: aString)! !

Object subclass: #ObjectDiffGUI
	instanceVariableNames: 'diffSheet diffListSelection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff-GUI'!

!ObjectDiffGUI classSide methodsFor: 'instance creation' stamp: 'HwaJong 10/28/2012 19:41'!
on: aDiffSheet
^self new
	model: aDiffSheet! !

!ObjectDiffGUI methodsFor: 'list' stamp: 'HwaJong 10/31/2012 12:25'!
balloonTextForNode: aPluggableTreeItemNode 
^aPluggableTreeItemNode item balloonText.! !

!ObjectDiffGUI methodsFor: 'list' stamp: 'HwaJong 10/30/2012 12:02'!
diffDetailListTreeItems
^(diffSheet isNil
	ifTrue: [1 to: 5]
	ifFalse: [diffSheet listItems]) collect: [:each| PluggableTreeItemNode with: each model: self ]! !

!ObjectDiffGUI methodsFor: 'list' stamp: 'HwaJong 10/28/2012 19:38'!
diffListSelection
^diffListSelection isNil
	ifTrue: [0]
	ifFalse: [diffListSelection item].! !

!ObjectDiffGUI methodsFor: 'list' stamp: 'HwaJong 10/28/2012 19:38'!
diffListSelection: aPluggableTreeItemNode 
diffListSelection := aPluggableTreeItemNode.
self changed: #diffListSelection! !

!ObjectDiffGUI methodsFor: 'list' stamp: 'HwaJong 10/28/2012 19:35'!
hasNodeContents: object
^false! !

!ObjectDiffGUI methodsFor: 'list' stamp: 'HwaJong 10/31/2012 18:29'!
iconOfNode: aPluggableTreeItemNode 
^aPluggableTreeItemNode item
	ifIdentical: [ODIdenticalIcon formThatCached] ifEqual: [ODEqualIcon formThatCached] ifDifferent: [ODDifferentIcon formThatCached] ifLeftMissing: [ODLeftMissingIcon formThatCached] ifRightMissing: [ODRightMissingIcon formThatCached]
! !

!ObjectDiffGUI methodsFor: 'menu & action' stamp: 'HwaJong 10/31/2012 11:54'!
innerDiff
(ObjectDiffGUI on: (diffListSelection item innerDifference)) open.! !

!ObjectDiffGUI methodsFor: 'accessing' stamp: 'HwaJong 10/28/2012 19:43'!
model: aDiffSheet 
diffSheet := aDiffSheet! !

!ObjectDiffGUI methodsFor: 'display' stamp: 'HwaJong 10/31/2012 11:36'!
open
|builder list window|
builder := UITheme builder.
list := builder newTreeFor: self list: #diffDetailListTreeItems selected: #diffListSelection changeSelected: #diffListSelection:.
list getMenuSelector: #popUpMenu:.
window := list openInWindowLabeled: 'Diffy Diffy Diff Diff'.
window extent: 320@460.! !

!ObjectDiffGUI methodsFor: 'menu & action' stamp: 'HwaJong 10/31/2012 12:12'!
popUpMenu: aMenuMorph 
diffListSelection item canOpenInnerDifference
	ifTrue: [aMenuMorph add: 'inner diff' action: #innerDiff].
^aMenuMorph! !

!ObjectDiffGUI methodsFor: 'list' stamp: 'HwaJong 10/30/2012 12:32'!
printNode: aPluggableTreeItemNode 
^aPluggableTreeItemNode item oneColumnPrintString.! !
